package property;

import com.pholser.junit.quickcheck.Property;
import com.pholser.junit.quickcheck.runner.JUnitQuickcheck;
import org.junit.runner.RunWith;

import static org.junit.Assert.assertEquals;
import static org.junit.Assume.assumeThat;
import static org.hamcrest.Matchers.lessThanOrEqualTo;

@RunWith(JUnitQuickcheck.class)
public class MinTest {
    @Property
    public void minReturnsFirstIfFirstIsMin(final int first, final int second) {
        assumeThat(first, lessThanOrEqualTo(second));
        assertEquals(first, Min.min(first, second));
    }

    @Property
    public void minReturnsSecondIfSecondIsMin(final int first, final int second) {
        assumeThat(second, lessThanOrEqualTo(first));
        assertEquals(second, Min.min(first, second));
    }
}
