package property;

import com.pholser.junit.quickcheck.generator.GenerationStatus;
import com.pholser.junit.quickcheck.generator.Size;
import com.pholser.junit.quickcheck.generator.Generator;
import com.pholser.junit.quickcheck.generator.ComponentizedGenerator;
import com.pholser.junit.quickcheck.random.SourceOfRandomness;

public class MyListGenerator extends ComponentizedGenerator<MyList> {
//public class MyListGenerator extends Generator<MyList> {
    // begin instance variables
    private Size configSize;
    
    // end instance variables
    public MyListGenerator() {
        super(MyList.class);
        configSize = null;
    }

    public void configure(Size configSize) {
        this.configSize = configSize;
    }

    public int numberOfNeededComponents() {
        return 1;
    }
    
    private int size(SourceOfRandomness random, GenerationStatus status) {
        if (configSize == null) {
            return status.size();
        } else {
            return random.nextInt(configSize.min(), configSize.max());
        }
    }
    
    public MyList generate(final SourceOfRandomness random,
                           final GenerationStatus status) {
        final int size = size(random, status);
        final Generator itemGenerator = componentGenerators().get(0);
        MyList retval = new EmptyList();
        
        for (int num = 0; num < size; num++) {
            retval = new NonEmptyList(itemGenerator.generate(random, status), retval);
        }
        return retval;
    }
}
