package property;

import com.pholser.junit.quickcheck.Property;
import com.pholser.junit.quickcheck.runner.JUnitQuickcheck;
import org.junit.runner.RunWith;

import static org.junit.Assert.assertEquals;
import static org.junit.Assume.assumeThat;
import static org.hamcrest.Matchers.greaterThan;

@RunWith(JUnitQuickcheck.class)
public class ReverseTest {
    @Property
    public void doubleReverseIsSame(final String input) {
        final String reverse1 = Reverse.reverseString(input);
        final String reverse2 = Reverse.reverseString(reverse1);
        assertEquals(input, reverse2);
    }

    @Property
    public void reverseFirstCharIsLast(final String input) {
        final int len = input.length();
        assumeThat(len, greaterThan(0));
        final String reversed = Reverse.reverseString(input);
        assertEquals(len, reversed.length());
        assertEquals(input.charAt(0),
                     reversed.charAt(len - 1));
    }
}
